%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')
%define debug_package %{nil}
%define daemon_user monitor
Name: op5-nachos
Version: %{op5version}
Release: %{op5release}%{?dist}
License: GPLv2
Vendor: OP5 AB
Url: http://www.op5.com
BuildRoot: %{_tmppath}/%{name}-%{version}
Summary: Naemon configuration management service
Group: Applications/Internet
Prefix: /opt/monitor/nachos
BuildRequires: gcc
BuildRequires: git
BuildRequires: python34-devel
%if 0%{?rhel} <= 6
Requires: mysql-server
BuildRequires: python-pip
BuildRequires: python-virtualenv
%else
Requires: mariadb-server
BuildRequires: python34-pip
BuildRequires: python34-virtualenv
%endif
Requires: monitor-nacoma
Requires: python34
Source: %name-%version.tar.gz


%description
Naemon configuration management service


%prep
%setup -q


%install
%{__rm} --recursive --force %{buildroot}
%{__mkdir} --parents --mode 755 %{buildroot}%{prefix}
%{__mkdir} --parents --mode 750 %{buildroot}/etc/sudoers.d
%{__mkdir} --parents --mode 755 dist
%{__cp} nachos.cfg %{buildroot}%{prefix}/nachos.cfg
%{__cp} nachos.sudo %{buildroot}/%{_sysconfdir}/sudoers.d/nachos

%if 0%{?rhel} <= 6
%{__mkdir} --parents --mode 755 %{buildroot}%{_initddir}
%{__cp} nachos.init %{buildroot}%{_initddir}/nachos
%else
%{__mkdir} --parents --mode 755 %{buildroot}%{_unitdir}
%{__cp} nachos.service %{buildroot}%{_unitdir}/nachos.service

%{__mkdir} --parents --mode 750 %{buildroot}/etc/rsyslog.d
%{__cp} nachos-rsyslog.conf %{buildroot}/%{_sysconfdir}/rsyslog.d/op5-rsyslog-nachos.conf
%endif

# The wheels are built in the ci_config pre step
%{__tar} cvfz dist.tar.gz dist
%{__install} -Dp -m0644 dist.tar.gz %{buildroot}%{prefix}/dist.tar.gz


%post
%if 0%{?rhel} <= 6
service nachos stop || exit 0
%else
systemctl stop nachos.service || exit 0
%endif

%if 0%{?rhel} <= 6
service mysqld start
%else
systemctl start mariadb
%endif

if [ $1 -eq 1 ]; then
	# Installing for the first time
	mysql -u root -e "CREATE DATABASE IF NOT EXISTS nachos CHARACTER SET = 'utf8' COLLATE = 'utf8_unicode_ci';"
	mysql -u root nachos -e "GRANT ALL PRIVILEGES ON nachos.* TO 'nachos'@'localhost' IDENTIFIED BY 'NACHOS_DBPASS';"
	mysql -u root nachos -e "GRANT ALL PRIVILEGES ON nachos.* TO 'nachos'@'%' IDENTIFIED BY 'NACHOS_DBPASS';"
fi


%posttrans
# Set up virtual environment
cd %{prefix}
/usr/bin/python3.4 -m venv --clear venv
%{__rm} --recursive --force dist
%{__tar} xvfz dist.tar.gz
# Like an obnoxious child, pbr just has to be installed first...
venv/bin/pip install --upgrade -f dist --no-index pbr
venv/bin/pip install --upgrade -f dist --no-index nachos
%{__chown} -R %{daemon_user} .

# Sync database schema to current version.
%{prefix}/venv/bin/nachos-manage --config-file %{prefix}/nachos.cfg db_sync

# Start Nachos
%if 0%{?rhel} <= 6
service nachos start
%else
systemctl daemon-reload
# Restart rsyslog for the new logging rules
systemctl restart rsyslog
systemctl start nachos.service
%endif

# Enable Nachos
%if 0%{?rhel} <= 6
chkconfig --add nachos
%else
systemctl enable nachos.service
%endif


%preun
%if 0%{?rhel} <= 6
%{nil}
%else
%systemd_preun nachos.service
%endif

if [ $1 -eq 0 ] ; then
    # Uninstall
    %{__rm} --recursive --force %{prefix}/venv %{prefix}/dist
fi


%files
%defattr(644,root,root,755)
%{prefix}/dist.tar.gz
%attr(440,root,root) %{_sysconfdir}/sudoers.d/nachos
%attr(640,monitor,apache) %config(noreplace) %{prefix}/nachos.cfg
%if 0%{?rhel} <= 6
%config(noreplace) %attr(755, root, root) %{_initddir}/nachos
%else
%config(noreplace) %attr(664,root,root) %{_unitdir}/nachos.service
%attr(664,root,root) %{_sysconfdir}/rsyslog.d/op5-rsyslog-nachos.conf
%endif


%clean
%{__rm} --recursive --force %buildroot


%changelog
* Mon Oct 14 2019 Petter Nyström <pnystrom@op5.com>
- Include dependent wheels in RPM (no more relocatable venv)
* Fri May 18 2018 Robin Engström <rengstrom@op5.com>
- Add systemd files
* Tue May 15 2018 Robin Engström <rengstrom@op5.com>
- Initialize database on install
* Thu Apr 19 2018 Robin Engström <rengstrom@op5.com>
- Initial build
